#include <opencv2/opencv.hpp>
#include <vector>
#include <string>
#include<iostream>
#include <sstream>
#include <stdlib.h>
#include <memory.h>
#include <fstream>
#include <direct.h>
#include <windows.h>

using namespace std;
using namespace cv;

string STR_DATASET_PATH1a = "C:\\Data Drive\\Opencv Projects\\FinalConvexHullRatioAPR21\\UNL_PGCDataset\\";  //Directory of the dataset (view 0)
string STR_DATASET_PATH1b = "\\SideView0";
string STR_DATASET_PATH2a = "C:\\Data Drive\\Opencv Projects\\FinalConvexHullRatioAPR21\\UNL_PGCDataset\\";  //Directory of the dataset (view 90)
string STR_DATASET_PATH2b = "\\TopView";

string FOLDER_NAME_LIST = "C:\\Data Drive\\Opencv Projects\\FinalConvexHullRatioAPR21\\foldernamelist.txt";  // File of the plant ID list
string STR_IMNAME_LIST  = "C:\\Data Drive\\Opencv Projects\\FinalConvexHullRatioAPR21\\UNL_PGCDataset\\imnamelist.txt"; // File of the image name list

string STR_RESULT_SIDEVIEW0 = "C:\\Data Drive\\Opencv Projects\\AspectRatioAPR22\\AspectRatioFiles\\Result-Sideview0.txt";
string STR_RESULT_TOPVIEW  = "C:\\Data Drive\\Opencv Projects\\AspectRatioAPR22\\AspectRatioFiles\\Result-TopView.txt";
string STR_RESULT_RATIO      = "C:\\Data Drive\\Opencv Projects\\AspectRatioAPR22\\AspectRatioFiles\\Result_ratio.txt";


string STR_DATASET_PATH1;
string STR_RESULT_PATH1;
string STR_RESULT_PATH2;
string STR_DATASET_PATH2;


double BoundingBoxHeight(Mat1b originalImage, Mat1b backgroundImage, Mat3b & contour);  // Function declaration
double MinCircleDiameter(Mat3b originalImage, Mat3b & contour);


void StringToFileName(string FolderName){

	STR_DATASET_PATH1=STR_DATASET_PATH1a + FolderName + STR_DATASET_PATH1b;
	STR_DATASET_PATH2=STR_DATASET_PATH2a + FolderName + STR_DATASET_PATH2b;
	}


int main()
{
	double e1 = getTickCount();

	string FolderName, FileName;
	string FileIdentifierSV0, FileLocationSV0,FileIdentifierTV, FileLocationTV, FileIdentifier; 
	string SourceFileLocationSV0, DestinationFileLocationSV0, SourceFileLocationTV, DestinationFileLocationTV; 	

	
	std::ifstream FolderNameList(FOLDER_NAME_LIST.c_str());

	if(!FolderNameList.is_open())
	{
		cout<<"FOLDER_NAME_LIST File cannot be opened";
		return 0;
	}

	// For sideview0

	ofstream ResultSideview0(STR_RESULT_SIDEVIEW0.c_str(),std::ofstream::out);

	//---------------------------------------------------------------------------

	// For topview
	ofstream ResultTopeview(STR_RESULT_TOPVIEW.c_str(),std::ofstream::out);

	//----------------------------------------------------------------------------
	// For Ratio

	ofstream ResultRatio(STR_RESULT_RATIO.c_str(),std::ofstream::out);

	while(!FolderNameList.eof()){

		cout<<"Program title: To compute ratio of height of plants in side view and diameter in topview"<<endl;
		cout<<"Developed by: SRUTI DAS CHOUDHURY"<<endl;
		cout<<"---------------------------------------------"<<endl;
		std::wcout << (wchar_t)0xA9 << " Laboratory for Image-based Innovation in Plant Phenotyping (I2P2 Lab)" << std::endl;
		
		cout<<"-------------------------------------------------------------"<<endl;
		
				
 //--------------------------------------------------------------------------------------------------------------------------------

				
		double BBHeight;
		double MCDiameter;
		double AspectRatio;

		int counter=1;

		Mat1b backgroundImage0;

 //------------------------------------------------------------------------------

 		getline(FolderNameList,FolderName);
		
		StringToFileName(FolderName);

		cout<<"The name of folder under processing: \t"<<FolderName<<endl;

		STR_RESULT_PATH1 = "C:\\Data Drive\\Opencv Projects\\AspectRatioAPR22\\Result-Sideview0";
		STR_RESULT_PATH2 = "C:\\Data Drive\\Opencv Projects\\AspectRatioAPR22\\Result-TopView";

		
		std::ifstream FileNameList(STR_IMNAME_LIST.c_str());
//---------------------------------------------------------------------------------

		while (!FileNameList.eof()){

						
		getline(FileNameList,FileName);

							
			if(FileName.compare("Day_001.png")==0){			

				backgroundImage0 = imread((STR_DATASET_PATH1+"\\"+FileName).c_str(),IMREAD_GRAYSCALE);
				

				}else{

			FileIdentifier = FolderName+FileName;		

			FileIdentifierSV0 = FolderName+"_SV0_"+FileName;
			SourceFileLocationSV0=STR_DATASET_PATH1+"\\"+FileName;
			DestinationFileLocationSV0=STR_RESULT_PATH1+"\\"+FileIdentifierSV0;

			
			cout<<"Now processing sideview0 image \t"<<counter<<":\t "<<FileName<<endl;

			Mat1b originalImage0 = imread(SourceFileLocationSV0.c_str(), IMREAD_GRAYSCALE);

			Mat3b contour0(originalImage0.rows, originalImage0.cols, Vec3b(0,0,0));

			BBHeight = BoundingBoxHeight(originalImage0, backgroundImage0, contour0);

			imwrite(DestinationFileLocationSV0.c_str(), contour0);

			// ==============================================================================================

			FileIdentifierTV = FolderName+"_TV_"+FileName;
			SourceFileLocationTV=STR_DATASET_PATH2+"\\"+FileName;
			DestinationFileLocationTV=STR_RESULT_PATH2+"\\"+FileIdentifierTV;

			cout<<"Now processing topview image \t "<<counter<<":\t "<<FileName<<endl;
				
			Mat3b originalImageTV = imread(SourceFileLocationTV.c_str(), IMREAD_COLOR);

			Mat3b contourTV(originalImageTV.rows, originalImageTV.cols, Vec3b(0,0,0)); 			

			MCDiameter = MinCircleDiameter(originalImageTV, contourTV);

			imwrite(DestinationFileLocationTV.c_str(), contourTV);

			//=================================================================================================

			// Finding the ratio and saving it into respective files

			AspectRatio=BBHeight/MCDiameter;

			ResultSideview0<<FileIdentifierSV0<<"\t"<<BBHeight<<endl;
			ResultTopeview<<FileIdentifierTV<<"\t"<<MCDiameter<<endl;
			ResultRatio<<FileIdentifier<<"\t"<<AspectRatio<<endl;

			
			counter++;
			}
		}
		FileNameList.close();
	}

	FolderNameList.close();
	ResultSideview0.close();
	ResultTopeview.close();
	ResultRatio.close();

	cout<<"All done! \n\nPress any key to continue ..."<<endl;

	double e2 = getTickCount();

	double time = (e2 - e1)/getTickFrequency();
	cout << "The total time of execution" <<time << endl;

	while (!getchar())
	{
		return 0;
	}	
}	// End of main

//--------------------------------------------------------------------------------------------------


double BoundingBoxHeight(Mat1b originalImage, Mat1b backgroundImage, Mat3b & contour)
	 
{
	double BBH=0.0;	   // Variable to store the height of the bounding rectangle

	// Create binary mask
    Mat1b grayImage;
    absdiff(originalImage, backgroundImage, grayImage);
    Mat1b binary;
    threshold(grayImage, binary, 80, 255, THRESH_BINARY);

    
    // Take a ROI
	Rect roi(350,0,binary.size().width-600,binary.size().height);
    Mat1b imageROI = binary(roi);
    


    // Apply morphological dilate, 2 times
	Mat1b binaryMorph;
    Mat1b kernel = getStructuringElement(MORPH_ELLIPSE, Size(3, 3));
    dilate(imageROI, binaryMorph, kernel, Point(-1, -1), 2);

   
    // Find blob contours
    vector<vector<Point>> contours;
    double largest_area = 0.0;
    int largest_contour_index = 0;
    findContours(binaryMorph.clone(), contours, RETR_EXTERNAL, CHAIN_APPROX_SIMPLE,roi.tl());

    if (!contours.empty())
    {
        // Find largest contour
        for (size_t i = 0; i < contours.size(); i++)
        {
            double a = contourArea(contours[i], false);
            if (a > largest_area)
            {
                largest_area = a;
                largest_contour_index = i;
            }
        }

        // Draw largest contors
		        
		drawContours(contour, contours, largest_contour_index, Scalar(255,255,255), CV_FILLED);

        // Find bounding rectangle of largest contour
		             
        Rect boundRect = boundingRect(Mat(contours[largest_contour_index]));

		//Display bounding rectangle of the biggest contour
		rectangle(contour,boundRect,Scalar(0,0,255),16);

		#if DISPLAY_ON
				namedWindow( "Contour", WINDOW_NORMAL);
				imshow("Contour", contour);
		#endif

		//Compute height of bounding rectangle

		BBH=boundRect.height;     
		
				
    }  // End if

	return BBH;

}  // End of function ConvexHullArea

//---------------------------------------------------------------------------------------------


double MinCircleDiameter(Mat3b originalImage, Mat3b & contour)
	 
{
			double MCD=0.0;

			int iLowH = 38;
			int iHighH = 72;

			int iLowS = 36; 
			int iHighS = 250;

			int iLowV = 36;
			int iHighV = 250;

	// Create binary mask
    
	Mat3b HSVImage;

	cvtColor(originalImage,HSVImage, CV_BGR2HSV);
   
    Mat1b binary;
    inRange(HSVImage, Scalar(iLowH, iLowS, iLowV), Scalar(iHighH, iHighS, iHighV), binary);

    
    // Take a ROI
	Rect roi(350,0,binary.size().width-600,binary.size().height);
    Mat1b imageROI = binary(roi);
    


    // Apply morphological erode and dialate, 2 times
	Mat1b binaryMorph;
    Mat1b kernel = getStructuringElement(MORPH_ELLIPSE, Size(3, 3));
    erode(imageROI, binaryMorph, kernel, Point(-1, -1), 2);
	dilate(binaryMorph, binaryMorph, kernel, Point(-1, -1), 2);

   
    // Find blob contours
    vector<vector<Point>> contours;
    double largest_area = 0.0;
    int largest_contour_index = 0;
    findContours(binaryMorph.clone(), contours, RETR_EXTERNAL, CHAIN_APPROX_SIMPLE,roi.tl());

    if (!contours.empty())
    {
        // Find largest contour
        for (size_t i = 0; i < contours.size(); i++)
        {
            double a = contourArea(contours[i], false);
            if (a > largest_area)
            {
                largest_area = a;
                largest_contour_index = i;
            }
        }

        // Draw largest contors
		        
		drawContours(contour, contours, largest_contour_index, Scalar(255,255,255), CV_FILLED);

        // Find minimum enclosing circle of largest contour

		float radius;
		Point2f center;

		minEnclosingCircle(contours[largest_contour_index], center, radius);
        

        // Draw center and the minimum bounding circle

        circle(contour, center, radius, Scalar(0,0,255), 13);
		circle(contour,Point(center.x, center.y),8,Scalar(0,0,255), 10);

		//Display convex hull and the biggest contour

		#if DISPLAY_ON
				namedWindow( "Contour", WINDOW_NORMAL);
				imshow("Contour", contour);
		#endif

		//Compute diameter of minimum enclosing circle

		MCD=radius*2;     
		
				
    }  // End if

	return MCD;

}  // End of function minimum enclosing circle